Index: pjproject/trunk/pjsip/build/pjsip.dsw
===================================================================
--- pjproject/trunk/pjsip/build/pjsip.dsw	(revision 63)
+++ pjproject/trunk/pjsip/build/pjsip.dsw	(revision 64)
@@ -58,16 +58,4 @@
 ###############################################################################
 
-Project: "test_pjsip"=.\test_pjsip.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
 Project: "pjsip_ua"=.\pjsip_ua.dsp - Package Owner=<4>
 
@@ -109,4 +97,22 @@
 ###############################################################################
 
+Project: "test_pjsip"=.\test_pjsip.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+    Begin Project Dependency
+    Project_Dep_Name pjlib
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjsip_core
+    End Project Dependency
+}}}
+
+###############################################################################
+
 Global:
 
Index: pjproject/trunk/pjsip/build/pjsip_core.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 63)
+++ pjproject/trunk/pjsip/build/pjsip_core.dsp	(revision 64)
@@ -104,5 +104,5 @@
 # Begin Source File
 
-SOURCE=..\src\pjsip\sip_misc.c
+SOURCE=..\src\pjsip\sip_errno.c
 # End Source File
 # Begin Source File
@@ -133,4 +133,8 @@
 
 SOURCE=..\src\pjsip\sip_uri.c
+# End Source File
+# Begin Source File
+
+SOURCE=..\src\pjsip\sip_util.c
 # End Source File
 # End Group
@@ -176,8 +180,4 @@
 # Begin Source File
 
-SOURCE=..\include\pjsip\sip_misc.h
-# End Source File
-# Begin Source File
-
 SOURCE=..\include\pjsip\sip_module.h
 # End Source File
@@ -217,4 +217,8 @@
 
 SOURCE=..\include\pjsip\sip_uri.h
+# End Source File
+# Begin Source File
+
+SOURCE=..\include\pjsip\sip_util.h
 # End Source File
 # End Group
Index: pjproject/trunk/pjsip/build/test_pjsip.dsp
===================================================================
--- pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 63)
+++ pjproject/trunk/pjsip/build/test_pjsip.dsp	(revision 64)
@@ -52,5 +52,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
-# ADD LINK32 wsock32.lib kernel32.lib netapi32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /profile /map /debug /machine:I386 /out:"..\bin\test-pjsip-i386-win32-vc6-release.exe"
+# ADD LINK32 dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib kernel32.lib netapi32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /profile /map /debug /machine:I386 /out:"..\bin\test-pjsip-i386-win32-vc6-release.exe"
 
 !ELSEIF  "$(CFG)" == "test_pjsip - Win32 Debug"
@@ -77,5 +77,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
-# ADD LINK32 wsock32.lib kernel32.lib netapi32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /out:"..\bin\test-pjsip-i386-win32-vc6-debug.exe" /pdbtype:sept
+# ADD LINK32 dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib kernel32.lib netapi32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /out:"..\bin\test-pjsip-i386-win32-vc6-debug.exe" /pdbtype:sept
 
 !ENDIF 
@@ -94,9 +94,13 @@
 # Begin Source File
 
-SOURCE="..\src\test-pjsip\test_msg.c"
+SOURCE="..\src\test-pjsip\msg.c"
 # End Source File
 # Begin Source File
 
-SOURCE="..\src\test-pjsip\test_uri.c"
+SOURCE="..\src\test-pjsip\test.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\test-pjsip\uri.c"
 # End Source File
 # End Group
Index: pjproject/trunk/pjsip/include/pjsip/print_util.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/print_util.h	(revision 63)
+++ pjproject/trunk/pjsip/include/pjsip/print_util.h	(revision 64)
@@ -20,7 +20,10 @@
 #define __PJSIP_PRINT_H__
 
+/* Minimum space left in the buffer */
+#define MIN_SPACE	10
+
 #define copy_advance_check(buf,str)   \
 	do { \
-	    if ((str).slen+10 >= (endbuf-buf)) return -1;	\
+	    if ((str).slen+MIN_SPACE >= (endbuf-buf)) return -1;	\
 	    pj_memcpy(buf, (str).ptr, (str).slen); \
 	    buf += (str).slen; \
@@ -32,5 +35,5 @@
     if (str2->slen) {
 	int printed = len1+str2->slen;
-	if (printed+10 >= (endbuf-buf)) return NULL;
+	if (printed+MIN_SPACE >= (endbuf-buf)) return NULL;
 	pj_memcpy(buf,str1,len1);
 	pj_memcpy(buf+len1, str2->ptr, str2->slen);
@@ -45,5 +48,5 @@
 	    if (str2.slen) { \
 		printed = len1+str2.slen; \
-		if (printed+10 >= (endbuf-buf)) return -1;	\
+		if (printed+MIN_SPACE >= (endbuf-buf)) return -1;	\
 		pj_memcpy(buf,str1,len1); \
 		pj_memcpy(buf+len1, str2.ptr, str2.slen); \
@@ -63,5 +66,5 @@
 	    if (str2.slen) { \
 		printed = len1+str2.slen+2; \
-		if (printed+10 >= (endbuf-buf)) return -1;	\
+		if (printed+MIN_SPACE >= (endbuf-buf)) return -1;	\
 		pj_memcpy(buf,str1,len1); \
 		*(buf+len1)=quotebegin; \
@@ -72,7 +75,33 @@
 	} while (0)
 
+#define copy_advance_pair_escape(buf,str1,len1,str2,unres)	\
+	do { \
+	    if (str2.slen) { \
+		pj_ssize_t esc_len; \
+		if (len1+str2.slen+MIN_SPACE >= (endbuf-buf)) return -1; \
+		pj_memcpy(buf,str1,len1); \
+		buf += len1; \
+		esc_len=pj_strncpy2_escape(buf, &str2, (endbuf-buf), &unres); \
+		if (esc_len < 0) return -1; \
+		buf += esc_len; \
+		if (endbuf-buf < MIN_SPACE) return -1; \
+	    } \
+	} while (0)
+
+
 #define copy_advance_no_check(buf,str)   \
-	pj_memcpy(buf, (str).ptr, (str).slen); \
-	buf += (str).slen;
+	do { \
+	    pj_memcpy(buf, (str).ptr, (str).slen); \
+	    buf += (str).slen; \
+	} while (0)
+
+#define copy_advance_escape(buf,str,unres)    \
+	do { \
+	    pj_ssize_t len = \
+		pj_strncpy2_escape(buf, &(str), (endbuf-buf), &(unres)); \
+	    if (len < 0) return -1; \
+	    buf += len; \
+	    if (endbuf-buf < MIN_SPACE) return -1; \
+	} while (0)
 
 #define copy_advance_pair_no_check(buf,str1,len1,str2)   \
Index: pjproject/trunk/pjsip/include/pjsip/sip_errno.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 63)
+++ pjproject/trunk/pjsip/include/pjsip/sip_errno.h	(revision 64)
@@ -22,8 +22,29 @@
 #include <pj/errno.h>
 
+PJ_BEGIN_DECL
+
+/*
+ * PJSIP error codes occupies 170000 - 219000, and mapped as follows:
+ *  - 170100 - 170799: mapped to SIP status code in response msg.
+ *  - 171000 - 171999: mapped to errors generated from PJSIP core.
+ */
+
+/**
+ * Get error message for the specified error code.
+ *
+ * @param status    The error code.
+ * @param buffer    The buffer where to put the error message.
+ * @param bufsize   Size of the buffer.
+ *
+ * @return	    The error message as NULL terminated string,
+ *                  wrapped with pj_str_t.
+ */
+PJ_DECL(pj_str_t) pjsip_strerror( pj_status_t status, char *buffer,
+				  pj_size_t bufsize);
+
 /**
  * Start of error code relative to PJ_ERRNO_START_USER.
  */
-#define PJSIP_ERRNO_START       (PJ_ERRNO_START_USER+10000)
+#define PJSIP_ERRNO_START       (PJ_ERRNO_START_USER)
 
 /**
@@ -44,5 +65,5 @@
 #define PJSIP_ERRNO_TO_SIP_STATUS(status)               \
          ((status>=PJSIP_ERRNO_FROM_SIP_STATUS(100) &&  \
-           status<PJSIP_ERRNO_FROM_SIP_STATUS(999)) ?   \
+           status<PJSIP_ERRNO_FROM_SIP_STATUS(800)) ?   \
           status-PJSIP_ERRNO_FROM_SIP_STATUS(0) : 599)
 
@@ -51,73 +72,157 @@
  * Start of PJSIP generated error code values.
  */
-#define PJSIP_ERRNO_START_PJSIP (PJSIP_ERRNO_START + 10000)
-
+#define PJSIP_ERRNO_START_PJSIP (PJSIP_ERRNO_START + 1000)
+
+/************************************************************
+ * GENERIC SIP ERRORS
+ ***********************************************************/
+/**
+ * @hideinitializer
+ * SIP object is busy.
+ */
+#define PJSIP_EBUSY		(PJSIP_ERRNO_START_PJSIP + 1)	/* 171001 */
+/**
+ * @hideinitializer
+ * SIP object with the same type already exists.
+ */
+#define PJSIP_ETYPEEXISTS	(PJSIP_ERRNO_START_PJSIP + 2)	/* 171002 */
+
+
+/************************************************************
+ * MESSAGING ERRORS
+ ***********************************************************/
 /**
  * @hideinitializer
  * Invalid message (syntax error)
  */
-#define PJSIP_EINVALIDMSG       (PJSIP_ERRNO_START_PJSIP + 0)
+#define PJSIP_EINVALIDMSG       (PJSIP_ERRNO_START_PJSIP + 20)	/* 171020 */
+/**
+ * @hideinitializer
+ * Unsupported URL scheme.
+ */
+#define PJSIP_EINVALIDSCHEME    (PJSIP_ERRNO_START_PJSIP + 21)	/* 171021 */
+/**
+ * @hideinitializer
+ * Message too long. See also PJSIP_ERXOVERFLOW.
+ */
+#define PJSIP_EMSGTOOLONG	(PJSIP_ERRNO_START_PJSIP + 22)	/* 171022 */
+/**
+ * @hideinitializer
+ * Message not completely received.
+ */
+#define PJSIP_EPARTIALMSG       (PJSIP_ERRNO_START_PJSIP + 23)	/* 171023 */
 /**
  * @hideinitializer
  * Missing required header(s).
  */
-#define PJSIP_EMISSINGHDR       (PJSIP_ERRNO_START_PJSIP + 1)
-/**
- * @hideinitializer
- * Unsupported URL scheme.
- */
-#define PJSIP_EINVALIDSCHEME    (PJSIP_ERRNO_START_PJSIP + 2)
+#define PJSIP_EMISSINGHDR       (PJSIP_ERRNO_START_PJSIP + 24)	/* 171024 */
+/**
+ * @hideinitializer
+ * Invalid Via header in response (sent-by, etc).
+ */
+#define PJSIP_EINVALIDVIA	(PJSIP_ERRNO_START_PJSIP + 25)	/* 171025 */
+/**
+ * @hideinitializer
+ * Multiple Via headers in response.
+ */
+#define PJSIP_EMULTIPLEVIA	(PJSIP_ERRNO_START_PJSIP + 26)	/* 171026 */
+
+/************************************************************
+ * TRANSPORT ERRORS
+ ***********************************************************/
+/**
+ * @hideinitializer
+ * Unsupported transport type.
+ */
+#define PJSIP_EUNSUPTRANSPORT	(PJSIP_ERRNO_START_PJSIP + 40)	/* 171040 */
+/**
+ * @hideinitializer
+ * Buffer is being sent, operation still pending.
+ */
+#define PJSIP_EPENDINGTX	(PJSIP_ERRNO_START_PJSIP + 41)	/* 171041 */
+/**
+ * @hideinitializer
+ * Rx buffer overflow. See also PJSIP_EMSGTOOLONG.
+ */
+#define PJSIP_ERXOVERFLOW         (PJSIP_ERRNO_START_PJSIP + 42)/* 171042 */
+
+
+/************************************************************
+ * TRANSACTION ERRORS
+ ***********************************************************/
 /**
  * @hideinitializer
  * Transaction has just been destroyed.
  */
-#define PJSIP_ETSXDESTROYED     (PJSIP_ERRNO_START_PJSIP + 3)
-/**
- * @hideinitializer
- * Buffer overflow. See also PJSIP_EMSGTOOLONG.
- */
-#define PJSIP_EOVERFLOW         (PJSIP_ERRNO_START_PJSIP + 4)
-/**
- * @hideinitializer
- * Message not completely received.
- */
-#define PJSIP_EPARTIALMSG       (PJSIP_ERRNO_START_PJSIP + 5)
-/**
- * @hideinitializer
- * Message too long. See also PJSIP_EOVERFLOW.
- */
-#define PJSIP_EMSGTOOLONG	(PJSIP_ERRNO_START_PJSIP + 6)
-/**
- * @hideinitializer
- * Buffer is being sent, operation still pending.
- */
-#define PJSIP_EPENDINGTX	(PJSIP_ERRNO_START_PJSIP + 7)
-/**
- * @hideinitializer
- * Unsupported transport type.
- */
-#define PJSIP_EUNSUPTRANSPORT	(PJSIP_ERRNO_START_PJSIP + 8)
-/**
- * @hideinitializer
- * Invalid Via header in response (sent-by, etc).
- */
-#define PJSIP_EINVALIDVIA	(PJSIP_ERRNO_START_PJSIP + 9)
-/**
- * @hideinitializer
- * Multiple Via headers in response.
- */
-#define PJSIP_EMULTIPLEVIA	(PJSIP_ERRNO_START_PJSIP + 9)
-/**
- * @hideinitializer
- * SIP object is busy.
- */
-#define PJSIP_EBUSY		(PJSIP_ERRNO_START_PJSIP + 10)
-/**
- * @hideinitializer
- * SIP object with the same type already exists.
- */
-#define PJSIP_ETYPEEXISTS	(PJSIP_ERRNO_START_PJSIP + 11)
-
-
+#define PJSIP_ETSXDESTROYED     (PJSIP_ERRNO_START_PJSIP + 60)	/* 171060 */
+
+
+/************************************************************
+ * URI COMPARISON RESULTS
+ ***********************************************************/
+/**
+ * @hideinitializer
+ * Scheme mismatch.
+ */
+#define PJSIP_ECMPSCHEME	(PJSIP_ERRNO_START_PJSIP + 80)	/* 171080 */
+/**
+ * @hideinitializer
+ * User part mismatch.
+ */
+#define PJSIP_ECMPUSER		(PJSIP_ERRNO_START_PJSIP + 81)	/* 171081 */
+/**
+ * @hideinitializer
+ * Password part mismatch.
+ */
+#define PJSIP_ECMPPASSWD	(PJSIP_ERRNO_START_PJSIP + 82)	/* 171082 */
+/**
+ * @hideinitializer
+ * Host part mismatch.
+ */
+#define PJSIP_ECMPHOST		(PJSIP_ERRNO_START_PJSIP + 83)	/* 171083 */
+/**
+ * @hideinitializer
+ * Port part mismatch.
+ */
+#define PJSIP_ECMPPORT		(PJSIP_ERRNO_START_PJSIP + 84)	/* 171084 */
+/**
+ * @hideinitializer
+ * Transport parameter part mismatch.
+ */
+#define PJSIP_ECMPTRANSPORTPRM	(PJSIP_ERRNO_START_PJSIP + 85)	/* 171085 */
+/**
+ * @hideinitializer
+ * TTL parameter part mismatch.
+ */
+#define PJSIP_ECMPTTLPARAM	(PJSIP_ERRNO_START_PJSIP + 86)	/* 171086 */
+/**
+ * @hideinitializer
+ * User parameter part mismatch.
+ */
+#define PJSIP_ECMPUSERPARAM	(PJSIP_ERRNO_START_PJSIP + 87)	/* 171087 */
+/**
+ * @hideinitializer
+ * Method parameter part mismatch.
+ */
+#define PJSIP_ECMPMETHODPARAM	(PJSIP_ERRNO_START_PJSIP + 88)	/* 171088 */
+/**
+ * @hideinitializer
+ * Maddr parameter part mismatch.
+ */
+#define PJSIP_ECMPMADDRPARAM	(PJSIP_ERRNO_START_PJSIP + 89)	/* 171089 */
+/**
+ * @hideinitializer
+ * Parameter part in other_param mismatch.
+ */
+#define PJSIP_ECMPOTHERPARAM	(PJSIP_ERRNO_START_PJSIP + 90)	/* 171090 */
+/**
+ * @hideinitializer
+ * Parameter part in header_param mismatch.
+ */
+#define PJSIP_ECMPHEADERPARAM	(PJSIP_ERRNO_START_PJSIP + 91)	/* 171091 */
+
+
+
+PJ_END_DECL
 
 #endif	/* __PJSIP_SIP_ERRNO_H__ */
Index: pjproject/trunk/pjsip/include/pjsip/sip_event.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_event.h	(revision 63)
+++ pjproject/trunk/pjsip/include/pjsip/sip_event.h	(revision 64)
@@ -298,5 +298,5 @@
  * Get the event string from the event ID.
  * @param e the event ID.
- * @notes defined in sip_misc.c
+ * @notes defined in sip_util.c
  */
 PJ_DEF(const char *) pjsip_event_str(pjsip_event_id_e e);
Index: pjproject/trunk/pjsip/include/pjsip/sip_parser.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_parser.h	(revision 63)
+++ pjproject/trunk/pjsip/include/pjsip/sip_parser.h	(revision 64)
@@ -295,17 +295,19 @@
  * parsers.
  */
-extern
-pj_cis_t	pjsip_HOST_SPEC,	    /* For scanning host part. */
-		pjsip_DIGIT_SPEC,	    /* Decimal digits */
-		pjsip_ALPHA_SPEC,	    /* Alpha (A-Z, a-z) */
-		pjsip_ALNUM_SPEC,	    /* Decimal + Alpha. */
-		pjsip_TOKEN_SPEC,	    /* Token. */
-		pjsip_HEX_SPEC,		    /* Hexadecimal digits. */
-		pjsip_PARAM_CHAR_SPEC,	    /* For scanning pname (or pvalue when it's not quoted.) */
-		pjsip_PROBE_USER_HOST_SPEC, /* Hostname characters. */
-		pjsip_PASSWD_SPEC,	    /* Password. */
-		pjsip_USER_SPEC,	    /* User */
-		pjsip_NEWLINE_OR_EOF_SPEC,  /* For eating up header.*/
-		pjsip_DISPLAY_SCAN_SPEC;    /* Used when searching for display name in URL. */
+extern pj_cis_t    
+    pjsip_HOST_SPEC,		/**< For scanning host part. */
+    pjsip_DIGIT_SPEC,		/**< Decimal digits */
+    pjsip_ALPHA_SPEC,		/**< Alpha (A-Z, a-z) */
+    pjsip_ALNUM_SPEC,		/**< Decimal + Alpha. */
+    pjsip_TOKEN_SPEC,		/**< Token. */
+    pjsip_HEX_SPEC,	        /**< Hexadecimal digits. */
+    pjsip_PARAM_CHAR_SPEC,      /**< For scanning pname (or pvalue when it's 
+				     not quoted.) */
+    pjsip_HDR_CHAR_SPEC,	/**< Chars in hname/havalue in URL. */
+    pjsip_PROBE_USER_HOST_SPEC, /**< Hostname characters. */
+    pjsip_PASSWD_SPEC,		/**< Password. */
+    pjsip_USER_SPEC,		/**< User */
+    pjsip_NEWLINE_OR_EOF_SPEC,  /**< For eating up header.*/
+    pjsip_DISPLAY_SCAN_SPEC;    /**< Used when searching for display name. */
 
 /*
Index: pjproject/trunk/pjsip/include/pjsip/sip_transaction.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 63)
+++ pjproject/trunk/pjsip/include/pjsip/sip_transaction.h	(revision 64)
@@ -130,4 +130,21 @@
 
 
+/**
+ * Create new transaction. Application would normally use 
+ * #pjsip_endpt_create_tsx rather than this function.
+ *
+ * @param pool	    Pool to use by the transaction.
+ * @param endpt	    Endpoint.
+ * @param p_tsx	    Pointer to return the transaction.
+ *
+ * @return	    PJ_SUCCESS or the appropriate error code.
+ *
+ * @see pjsip_endpt_create_tsx
+ *
+ */
+PJ_DEF(pj_status_t) pjsip_tsx_create( pj_pool_t *pool,
+				      pjsip_endpoint *endpt,
+				      pjsip_transaction **p_tsx);
+
 /** 
  * Init transaction as UAC from the specified transmit data (\c tdata).
Index: pjproject/trunk/pjsip/include/pjsip/sip_uri.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_uri.h	(revision 63)
+++ pjproject/trunk/pjsip/include/pjsip/sip_uri.h	(revision 64)
@@ -27,4 +27,5 @@
 #include <pjsip/sip_types.h>
 #include <pjsip/sip_config.h>
+#include <pj/list.h>
 
 PJ_BEGIN_DECL
@@ -37,4 +38,51 @@
  * @{
  */
+
+/**
+ * Generic parameter, normally used in other_param or header_param.
+ */
+typedef struct pjsip_param
+{
+    PJ_DECL_LIST_MEMBER(struct pjsip_param);	/**< Generic list member.   */
+    pj_str_t	    name;			/**< Param/header name.	    */
+    pj_str_t	    value;			/**< Param/header value.    */
+} pjsip_param;
+
+
+/**
+ * Find the specified parameter name in the list. The name will be compared
+ * in case-insensitive comparison.
+ *
+ * @param param_list	List of parameters to find.
+ * @param name		Parameter/header name to find.
+ *
+ * @return		The parameter if found, or NULL.
+ */
+PJ_DECL(pjsip_param*) pjsip_param_find( pjsip_param *param_list,
+					const pj_str_t *name );
+
+
+/**
+ * Find the specified parameter name in the list. The name will be compared
+ * in case-insensitive comparison.
+ *
+ * @param param_list	List of parameters to find.
+ * @param name		Parameter/header name to find.
+ *
+ * @return		The parameter if found, or NULL.
+ */
+PJ_DECL(const pjsip_param*) pjsip_param_cfind(const pjsip_param *param_list,
+					      const pj_str_t *name );
+
+
+/**
+ * Duplicate the parameters.
+ *
+ * @param pool		Pool to allocate memory from.
+ * @param dst_list	Destination list.
+ * @param src_list	Source list.
+ */
+PJ_DECL(void) pjsip_param_clone(pj_pool_t *pool, pjsip_param *dst_list,
+				const pjsip_param *src_list);
 
 /**
@@ -90,8 +138,9 @@
      * @param uri1 the first URI (self).
      * @param uri2 the second URI.
-     * @return zero if equal.
-     */
-    int	(*p_compare)(pjsip_uri_context_e context, 
-		     const void *uri1, const void *uri2);
+     * @return PJ_SUCCESS if equal, or otherwise the error status which
+     *		    should point to the mismatch part.
+     */
+    pj_status_t	(*p_compare)(pjsip_uri_context_e context, 
+			     const void *uri1, const void *uri2);
 
     /** 
@@ -138,5 +187,4 @@
 #define PJSIP_URI_SCHEME_IS_TEL(url)	\
     (pj_strnicmp2(pjsip_uri_get_scheme(url), "tel", 3)==0)
-
 
 
@@ -157,6 +205,6 @@
     int		    lr_param;		/**< Optional loose routing param, or zero */
     pj_str_t	    maddr_param;	/**< Optional maddr param */
-    pj_str_t	    other_param;	/**< Other parameters grouped together. */
-    pj_str_t	    header_param;	/**< Optional header parameter. */
+    pjsip_param	    other_param;	/**< Other parameters grouped together. */
+    pjsip_param	    header_param;	/**< Optional header parameter. */
 } pjsip_url;
 
@@ -208,8 +256,9 @@
  * @param uri1	    The first URI.
  * @param uri2	    The second URI.
- * @return	    Zero if equal.
- */
-PJ_INLINE(int) pjsip_uri_cmp(pjsip_uri_context_e context, 
-			     const void *uri1, const void *uri2)
+ * @return	    PJ_SUCCESS if equal, or otherwise the error status which
+ *		    should point to the mismatch part.
+ */
+PJ_INLINE(pj_status_t) pjsip_uri_cmp(pjsip_uri_context_e context, 
+				     const void *uri1, const void *uri2)
 {
     return (*((const pjsip_uri*)uri1)->vptr->p_compare)(context, uri1, uri2);
Index: pjproject/trunk/pjsip/include/pjsip/sip_util.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip/sip_util.h	(revision 64)
+++ pjproject/trunk/pjsip/include/pjsip/sip_util.h	(revision 64)
@@ -0,0 +1,192 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJSIP_SIP_MISC_H__
+#define __PJSIP_SIP_MISC_H__
+
+#include <pjsip/sip_msg.h>
+
+PJ_BEGIN_DECL
+
+/**
+ * @defgroup PJSIP_ENDPT SIP Endpoint
+ * @ingroup PJSIP
+ * @{
+ */
+
+/**
+ * Create an independent request message. This can be used to build any
+ * request outside a dialog, such as OPTIONS, MESSAGE, etc. To create a request
+ * inside a dialog, application should use #pjsip_dlg_create_request.
+ *
+ * Once a transmit data is created, the reference counter is initialized to 1.
+ *
+ * @param endpt	    Endpoint instance.
+ * @param method    SIP Method.
+ * @param target    Target URI.
+ * @param from	    URL to put in From header.
+ * @param to	    URL to put in To header.
+ * @param contact   URL to put in Contact header.
+ * @param call_id   Optional Call-ID (put NULL to generate unique Call-ID).
+ * @param cseq	    Optional CSeq (put -1 to generate random CSeq).
+ * @param text	    Optional text body (put NULL to omit body).
+ * @param p_tdata   Pointer to receive the transmit data.
+ *
+ * @return	    PJ_SUCCESS, or the appropriate error code.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_create_request( pjsip_endpoint *endpt, 
+						 const pjsip_method *method,
+						 const pj_str_t *target,
+						 const pj_str_t *from,
+						 const pj_str_t *to, 
+						 const pj_str_t *contact,
+						 const pj_str_t *call_id,
+						 int cseq, 
+						 const pj_str_t *text,
+						 pjsip_tx_data **p_tdata);
+
+/**
+ * Create an independent request message from the specified headers. This
+ * function will shallow clone the headers and put them in the request.
+ *
+ * Once a transmit data is created, the reference counter is initialized to 1.
+ *
+ * @param endpt	    Endpoint instance.
+ * @param method    SIP Method.
+ * @param target    Target URI.
+ * @param from	    URL to put in From header.
+ * @param to	    URL to put in To header.
+ * @param contact   URL to put in Contact header.
+ * @param call_id   Optional Call-ID (put NULL to generate unique Call-ID).
+ * @param cseq	    Optional CSeq (put -1 to generate random CSeq).
+ * @param text	    Optional text body (put NULL to omit body).
+ * @param p_tdata   Pointer to receive the transmit data.
+ *
+ * @return	    PJ_SUCCESS, or the appropriate error code.
+ */
+PJ_DECL(pj_status_t)
+pjsip_endpt_create_request_from_hdr( pjsip_endpoint *endpt,
+				     const pjsip_method *method,
+				     const pjsip_uri *target,
+				     const pjsip_from_hdr *from,
+				     const pjsip_to_hdr *to,
+				     const pjsip_contact_hdr *contact,
+				     const pjsip_cid_hdr *call_id,
+				     int cseq,
+				     const pj_str_t *text,
+				     pjsip_tx_data **p_tdata);
+
+/**
+ * Send outgoing request and initiate UAC transaction for the request.
+ * This is an auxiliary function to be used by application to send arbitrary
+ * requests outside a dialog. To send a request within a dialog, application
+ * should use #pjsip_dlg_send_msg instead.
+ *
+ * @param endpt	    The endpoint instance.
+ * @param tdata	    The transmit data to be sent.
+ * @param timeout   Optional timeout for final response to be received, or -1 
+ *		    if the transaction should not have a timeout restriction.
+ * @param token	    Optional token to be associated with the transaction, and 
+ *		    to be passed to the callback.
+ * @param cb	    Optional callback to be called when the transaction has
+ *		    received a final response. The callback will be called with
+ *		    the previously registered token and the event that triggers
+ *		    the completion of the transaction.
+ *
+ * @return	    PJ_SUCCESS, or the appropriate error code.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_send_request( pjsip_endpoint *endpt,
+					       pjsip_tx_data *tdata,
+					       int timeout,
+					       void *token,
+					       void (*cb)(void*,pjsip_event*));
+
+/**
+ * Construct a minimal response message for the received request. This function
+ * will construct all the Via, Record-Route, Call-ID, From, To, CSeq, and 
+ * Call-ID headers from the request.
+ *
+ * Note: the txdata reference counter is set to ZERO!.
+ *
+ * @param endpt	    The endpoint.
+ * @param rdata	    The request receive data.
+ * @param code	    Status code to be put in the response.
+ * @param p_tdata   Pointer to receive the transmit data.
+ *
+ * @return	    PJ_SUCCESS, or the appropriate error code.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_create_response( pjsip_endpoint *endpt,
+						  const pjsip_rx_data *rdata,
+						  int code,
+						  pjsip_tx_data **p_tdata);
+
+/**
+ * Construct a full ACK request for the received non-2xx final response.
+ * This utility function is normally called by the transaction to construct
+ * an ACK request to 3xx-6xx final response.
+ * The generation of ACK message for 2xx final response is different than
+ * this one.
+ * 
+ * @param endpt	    The endpoint.
+ * @param tdata	    On input, this contains the original INVITE request, and on
+ *		    output, it contains the ACK message.
+ * @param rdata	    The final response message.
+ */
+PJ_DECL(void) pjsip_endpt_create_ack( pjsip_endpoint *endpt,
+				      pjsip_tx_data *tdata,
+				      const pjsip_rx_data *rdata );
+
+
+/**
+ * Construct CANCEL request for the previously sent request.
+ *
+ * @param endpt	    The endpoint.
+ * @param tdata	    The transmit buffer for the request being cancelled.
+ * @param p_tdata   Pointer to receive the transmit data.
+ *
+ * @return	    PJ_SUCCESS, or the appropriate error code.
+ */
+PJ_DECL(pj_status_t) pjsip_endpt_create_cancel( pjsip_endpoint *endpt,
+						pjsip_tx_data *tdata,
+						pjsip_tx_data **p_tdata);
+
+
+/**
+ * Get the address parameters (host, port, flag, TTL, etc) to send the
+ * response.
+ *
+ * @param pool	    The pool.
+ * @param tr	    The transport where the request was received.
+ * @param via	    The top-most Via header of the request.
+ * @param addr	    The send address concluded from the calculation.
+ *
+ * @return	    zero (PJ_OK) if successfull.
+ */
+PJ_DECL(pj_status_t) pjsip_get_response_addr(pj_pool_t *pool,
+					     const pjsip_transport *tr,
+					     const pjsip_via_hdr *via,
+					     pjsip_host_port *addr);
+
+/**
+ * @}
+ */
+
+PJ_END_DECL
+
+#endif	/* __PJSIP_SIP_MISC_H__ */
+
Index: pjproject/trunk/pjsip/include/pjsip_core.h
===================================================================
--- pjproject/trunk/pjsip/include/pjsip_core.h	(revision 63)
+++ pjproject/trunk/pjsip/include/pjsip_core.h	(revision 64)
@@ -21,7 +21,8 @@
 
 #include <pjsip/sip_types.h>
+#include <pjsip/sip_auth.h>
 #include <pjsip/sip_endpoint.h>
+#include <pjsip/sip_errno.h>
 #include <pjsip/sip_event.h>
-#include <pjsip/sip_misc.h>
 #include <pjsip/sip_module.h>
 #include <pjsip/sip_msg.h>
@@ -31,5 +32,5 @@
 #include <pjsip/sip_transport.h>
 #include <pjsip/sip_uri.h>
-#include <pjsip/sip_auth.h>
+#include <pjsip/sip_util.h>
 
 #endif	/* __PJSIP_CORE_H__ */
Index: pjproject/trunk/pjsip/src/pjsip-simple/event_notify.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-simple/event_notify.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip-simple/event_notify.c	(revision 64)
@@ -19,5 +19,5 @@
 #include <pjsip_simple/event_notify.h>
 #include <pjsip/sip_msg.h>
-#include <pjsip/sip_misc.h>
+#include <pjsip/sip_util.h>
 #include <pjsip/sip_endpoint.h>
 #include <pjsip/sip_module.h>
Index: pjproject/trunk/pjsip/src/pjsip-simple/messaging.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-simple/messaging.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip-simple/messaging.c	(revision 64)
@@ -23,5 +23,5 @@
 #include <pjsip/sip_event.h>
 #include <pjsip/sip_module.h>
-#include <pjsip/sip_misc.h>
+#include <pjsip/sip_util.h>
 #include <pj/string.h>
 #include <pj/pool.h>
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_dialog.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_dialog.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_dialog.c	(revision 64)
@@ -25,5 +25,5 @@
 #include <pjsip/sip_endpoint.h>
 #include <pjsip/sip_uri.h>
-#include <pjsip/sip_misc.h>
+#include <pjsip/sip_util.h>
 #include <pjsip/sip_module.h>
 #include <pjsip/sip_event.h>
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 64)
@@ -23,5 +23,5 @@
 #include <pjsip/sip_transaction.h>
 #include <pjsip/sip_event.h>
-#include <pjsip/sip_misc.h>
+#include <pjsip/sip_util.h>
 #include <pjsip/sip_auth_msg.h>
 #include <pj/pool.h>
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_ua.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_ua.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_ua.c	(revision 64)
@@ -22,5 +22,5 @@
 #include <pjsip/sip_module.h>
 #include <pjsip/sip_event.h>
-#include <pjsip/sip_misc.h>
+#include <pjsip/sip_util.h>
 #include <pjsip/sip_endpoint.h>
 #include <pjsip/sip_transaction.h>
